[LeetCode]Maximum Product Subarray

来源:互联网 发布:淘宝商家规则 编辑:程序博客网 时间:2024/05/21 21:44

今天准备再刷一遍leetcode,发现出了一道新题。刚开始想贪心一遍O(n)实现,没有想出来。于是从头开始想,暴力双循环,O(n*n)肯定没有问题。然后下午坐车的时候又想到了可以用二分法,后来终于又想出来了O(n)的实现,如下所示,不过怎么感觉自己的实现这么麻烦呢,对0考虑的太多了。后面贴的别人的算法就比较简洁。

Find the contiguous subarray within an array (containing at least one number) which has the largest product.

For example, given the array [2,3,-2,4],

the contiguous subarray [2,3] has the largest product = 6.

int maxProduct(int A[], int n) {        int res = A[0];    int nmax = A[0] < 0 ? A[0] : 0;    int pmax = A[0] > 0 ? A[0] : 0;        for (int i = 1; i < n; i++)    {        if (A[i] == 0)        {            nmax = pmax = 0;        }        else if (A[i] > 0)        {            nmax *= A[i];            pmax = pmax != 0 ? pmax * A[i] : A[i];        }        else        {            swap(pmax, nmax);            nmax = nmax != 0 ? nmax * A[i] : A[i];            pmax *= A[i];        }        res = max(res, pmax);    }    return res;}


http://blog.csdn.net/sbitswc/article/details/39546719

public int maxProduct2(int[] A) {if(A.length<=0) return 0;if(A.length==1) return A[0];int curMax = A[0];int curMin = A[0];int ans = A[0];for(int i=1;i<A.length;i++){int temp = curMin *A[i];curMin = Math.min(A[i], Math.min(temp, curMax*A[i]));curMax = Math.max(A[i], Math.max(temp, curMax*A[i]));ans = Math.max(ans, curMax);}return ans;}

思路也很清晰:

Analysis:

similar like Maximum Subarray question

difference is the max value could be get from 3 situations

current maxValue * A[i]  if A[i]>0

current minValue * A[i]  if A[i]<0

A[i]  

We need to record current maxValue, current minValue and update them every time get the new product


0 0
原创粉丝点击